# bogen.py

from figuren.grafikfenster import Zeichenflaeche
from figuren.figur import Figur
from math import pi

### ---------------------------------------------------
class Bogen(Figur):
    """Die Klasse Bogen ermoeglicht das Zeichnen
    und Bearbeiten eines Bogens"""

    def __init__(self,
                 mitteX=50,
                 mitteY=50,
                 radius=60,
                 winkelStart=10,
                 winkelEnde=170,
                 farbe="BLACK",
                 fuellfarbe=None):
        self.__mX, self.__mY, self.__r  = mitteX, mitteY, radius
        self.__grundfigur = None
        # Die winkel muessen auf Bogenmass umgerechnet werden
        self.__wS, self.__wE = winkelStart*pi/180, winkelEnde*pi/180
        Figur.__init__(self, self.__mX, self.__mY, 0, 0, 0, farbe, fuellfarbe)

    def _SetzeGrundfigur(self):
        """Definiert den Pfad ohne Transformation"""
        gc = Zeichenflaeche.GibZeichenflaeche().GibGC()
        path = gc.CreatePath()
        #AddArc(wxDouble x, wxDouble y, wxDouble r,
        # wxDouble startAngle, wxDouble endAngle, bool clockwise)
        path.AddArc(0, 0, self.__r, self.__wS, self.__wE, True)
        box=path.GetBox()
        # Fuer die Transformation:
        self._Figur__breite = box.width
        self._Figur__hoehe = box.height
        return path
        
    def GibFigur(self):
        """Uebergibt den Pfad der Transformation"""
        if self.__grundfigur == None:
            self.__grundfigur = self._SetzeGrundfigur()
        gc = Zeichenflaeche.GibZeichenflaeche().GibGC()
        path = gc.CreatePath()
        path.AddPath(self.__grundfigur)
        return self.Transformiere(path)
