# linie.py

from figuren.grafikfenster import Zeichenflaeche
from figuren.figur import Figur

### ---------------------------------------------------
class Linie(Figur):
    """Klasse Linie ermoeglicht das Zeichnen
    und Bearbeiten einer Linie"""

    def __init__(self,
                 xPos=0,
                 yPos=140,
                 breite=100,
                 hoehe=0,
                 winkel=0,
                 farbe="brown"):
        Figur.__init__(self, xPos, yPos, breite, hoehe, winkel, farbe, None)

    def AendereFuellfarbe(self, neueFuellfarbe=None):
        """Linien haben keine Fuellfarbe"""
        pass
        
    def GibFigur(self):
        """Definiert den Pfad und transformiert ihn."""
        gc = Zeichenflaeche.GibZeichenflaeche().GibGC()
        path = gc.CreatePath()
        
        # lokale Variable zur Schreibvereinfachung
        b, h = self.GibBreite(), self.GibHoehe()
        path.MoveToPoint(0, 0)
        path.AddLineToPoint(b, h)
        
        return self.Transformiere(path)
