# nEck.py

from figuren.grafikfenster import Zeichenflaeche
from figuren.figur import Figur

# Hilfsfunktionen
first = lambda p: p[0]
second = lambda p: p[1]

### ---------------------------------------------------
class N_Eck(Figur):
    """Klasse Linie ermoeglicht das Zeichnen
    und Bearbeiten eines n-Ecks"""

    def __init__(self,
                 xPos=100,
                 yPos=100,
                 ecken=((0,0),(20,10),(0,20)),
                 winkel=0,
                 farbe="brown",
                 fuellfarbe='yellow'):
        self.__ecken=ecken
        breite = max(map(first,ecken)) - min(map(first,ecken))
        hoehe = max(map(second,ecken)) - min(map(second,ecken))
        Figur.__init__(self, xPos, yPos, breite, hoehe, winkel, farbe, fuellfarbe)

    def GibFigur(self):
        """Definiert den Pfad."""
        gc = Zeichenflaeche.GibZeichenflaeche().GibGC()
        path = gc.CreatePath()
        
        # lokale Variable zur Schreibvereinfachung
        b, h = self.GibBreite(), self.GibHoehe()
        path.MoveToPoint(self.__ecken[0])
        for i in range(1,len(self.__ecken)):
            path.AddLineToPoint(self.__ecken[i])
        path.CloseSubpath()
        
        return self.Transformiere(path)
