# text.py

import wx
from figuren.grafikfenster import Zeichenflaeche
from figuren.figur import Figur
from figuren.figurenGruppe import FigurenGruppe

### ---------------------------------------------------
class Text(Figur):
    """Klasse Text ermoeglicht das Zeichnen und Bearbeiten von Text"""

    def __init__(self,
                 text="",
                 xPos=0,
                 yPos=0,
                 winkel=0,
                 farbe="black"):
        self.__text = text
        self.__font = None # nur bei besonderen Zeichen
        Figur.__init__(self, xPos, yPos, len(text)*10, 20, winkel, farbe, None)

    def IstText(self):
        '''Zur eindeutigen Identifikation von Textobjekten'''
        return True

    def GibFont(self):
        '''gibt das von SetzeFont gesetzte font-Objekt zurueck, sonst None'''
        return self.__font

    def SetzeFont(self,
                  pointSize=10,
                  family="DEFAULT",
                  style="NORMAL",
                  weight="FETT",
                  underline=False):
        '''pointSize: 10 ...
        family: "DEFAULT","ROMAN","SWISS"
        style: "NORMAL","KURSIV"
        weight: "NORMAL","FETT"'''
        self.Verberge()
        ff={"DEFAULT":wx.FONTFAMILY_DEFAULT,
            "ROMAN":wx.FONTFAMILY_ROMAN,
            "SWISS":wx.FONTFAMILY_SWISS}
        if not family in ff: family="DEFAULT"
        st={"NORMAL":wx.FONTSTYLE_NORMAL,"KURSIV":wx.FONTSTYLE_ITALIC}
        if not style in st: style="NORMAL"
        w={"NORMAL":wx.FONTWEIGHT_NORMAL ,"FETT":wx.FONTWEIGHT_BOLD}
        if not weight in w: weight="FETT"
        self.__font=wx.Font(pointSize,
                            ff[family],
                            st[style],
                            w[weight],
                            underline)
        self.Zeige()
    
    def AendereFuellfarbe(self, neueFuellfarbe=None):
        """Texte haben keine Fuellfarbe"""
        pass
    
    def SetzeGruppe(self, gruppe):
        """Gruppe geht nicht"""
        self.__gruppe = None

    def AendereText(self, text):
        self.Verberge()
        self.__text = text
        self.Zeige()

    def GibText(self):
        return self.__text
        
    def GibFigur(self):
        """Definiert den Pfad und transformiert ihn."""
        gc = Zeichenflaeche.GibZeichenflaeche().GibGC()
        path = gc.CreatePath()        
        # sinnlos, daher:        
        return self.Transformiere(path)
